# Readme

The folder contains the code to replicate all results in the manuscript.

## Prerequisites
Checking/Installing prerequisite libraries:

> python 3.6+ \
> numpy 1.19+ \
> matplotlib 3.3+ \
> seaborn 0.11+ \
> pandas 1.2+ \
> statsmodels 0.12+ \
> pgmpy 0.1.13+ \
> torch 1.7+

## Experiments on 2D Ising

To familiarize with the code, please see the notebook `Tutorial.ipynb`

To run the simulations, run the bash script `runner.sh`

To evaluate the sampler, run the script `eval.sh`

## Experiments on UAI

Download datasets `BN_1.uai` and `BN_8.uai` from [repository](http://sli.ics.uci.edu/~ihler/uai-data/).

Modify variable `filename` in `runner.sh` and `eval.sh` with the correct paths to the datasets.

To run the simulations, run the bash script `runner.sh`

To evaluate the sampler, run the script `eval.sh`

